# REAL changelog

## Version [0.3](https://git.ecdf.ed.ac.uk/pguaglia/real/commits/0.3) (2020-04-08)

#### New features

- Command line options:
  * `-d`, `--data` to specify the data directory with the CSV files,
  * `-e`, `--eval` to control the query execution semantics (corresponds to the
    `.eval` command in interactive mode),
  * `-q`, `--query` to specify a query expression to be executed in a batch way,
  * `-t`, `--tree` to control the printing of syntax trees (corresponds to the
    `.tree` command in interactive mode).

- Views (virtual tables). In interactive mode, a view is created with the syntax
  `VIEW-NAME := EXPRESSION`, where `EXPRESSION` may mention previously defined
  views. A view can be deleted with the command `.drop VIEW-NAME`, which results
  in an error if the view to be deleted is still used (directly or indirectly)
  in the definition of another view. Views do not persist across runs of the
  application.

#### Bug fixes

- A blank input at the command prompt now does not cause an EmptyStackException
  to be thrown (issue #2).

## Version [0.2.1](https://git.ecdf.ed.ac.uk/pguaglia/real/commits/0.2.1) (2020-03-02)

#### Bug fixes

- The union operation now returns the correct answers under set semantics.

## Version [0.2](https://git.ecdf.ed.ac.uk/pguaglia/real/commits/0.2) (2020-02-27)

#### New features

- Evaluation under bag semantics. The evaluation of RA expressions (`.eval`) can
  now be set to `OFF`, `SET` (set semantics; default) or `BAG` (bag semantics).

- Added duplicate elimination. Under bag semantics, this RA operation removes
  duplicates (multiple occurrences of the same row) from a table.

## Version [0.1](https://git.ecdf.ed.ac.uk/pguaglia/real/commits/0.1) (2020-01-30)

#### New features

- Import database tables from the CSV files in a given directory. For each CSV
  file, a table with the same name is created; its column names (table header)
  are taken from the first row of values in the file.

- Evaluate RA expressions under set semantics. Query execution is controlled by
  the `.eval` switch, which can be set to `ON` (default) or `OFF` (expressions
  are validated against the database schema, but they are not executed).

- Display the syntax tree of RA expressions. This is controlled by the `.tree`
  option, which can be set to `ON` (show the syntax tree) or `OFF` (default).
