package uk.ac.ed.pguaglia.real.db.engine;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Stream;

import uk.ac.ed.pguaglia.real.db.engine.DataValue.DataType;

public class BaseTable {

	private final String[] attributes; // in fetch order
	private final DataType[] types; // in fetch order
	private final Path datafile;

	public BaseTable(Path data, String[] attributes, DataType[] types) {
		// TODO: check sizes match
		this.datafile = data;
		this.types = types;
		this.attributes = attributes;
	}

	public Stream<Record> fetch() throws IOException {
		return Files.lines(datafile).map(s -> Record.of(s.split(","), types));
	}

	public List<String> attributes() {
		return Arrays.asList(attributes);
	}

	public List<DataType> types() {
		return Arrays.asList(types);
	}

	public DataType getDataType(String attr) {
		int pos = Arrays.asList(attributes).indexOf(attr);
		return types[pos];
	}

	public Path datafile() {
		return datafile;
	}
}
