package uk.ac.ed.pguaglia.real.db.engine;

import java.math.BigDecimal;

public class DataValue {

	public static enum DataType { NUMBER, TEXT }

	public final Object value;

	private DataValue(Object value) {
		this.value = value;
	}

	public static DataValue valueOf(String s, DataType t) {
		switch (t) {
		case NUMBER:
			return new DataValue(new BigDecimal(s));
		case TEXT:
			return new DataValue(new String(s));
		default:
			return null;
		}
	}

	@Override
	public String toString() {
		return this.value.toString();
	}
}
