package uk.ac.ed.pguaglia.real.db.engine;

import java.util.Arrays;

import org.apache.commons.lang3.ArrayUtils;

import uk.ac.ed.pguaglia.real.db.engine.DataValue.DataType;

public class Record {

	private Object[] data;

	public Record(int size) {
		data = new Object[size];
	}

	public Record(Object[] data) {
		this.data = data;
	}

	public static Record of(String[] rawValues, DataType[] types) {
		if (rawValues.length != types.length) {
			throw new IllegalArgumentException();
		}
		Record r = new Record(rawValues.length);
		for (int i=0; i < r.data.length; i++) {
			r.data[i] = DataValue.valueOf(rawValues[i], types[i]);
		}
		return r;
	}

	public Record append(Record r) {
		return new Record(ArrayUtils.addAll(this.data, r.data));
	}

	public Record project(int[] pos) {
		Record result = new Record(pos.length);
		for (int i=0; i < pos.length; i++) {
			result.data[i] = this.data[pos[i]];
		}
		return result;
	}

	@Override
	public String toString() {
		return Arrays.asList(this.data).toString();
	}
}
